diff -ruN vdr-1.5.2/osd.c vdr-1.5.3/osd.c
--- vdr-1.5.2/osd.c	2007-02-17 17:05:52.000000000 +0100
+++ vdr-1.5.3/osd.c	2007-06-10 14:16:36.000000000 +0200
@@ -4,11 +4,12 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.68 2007/02/17 16:05:52 kls Exp $
+ * $Id: osd.c 1.69 2007/06/10 12:16:36 kls Exp $
  */
 
 #include "osd.h"
 #include <math.h>
+#include <stdarg.h>
 #include <stdlib.h>
 #include <sys/ioctl.h>
 #include <sys/stat.h>
@@ -20,6 +21,18 @@
 cPalette::cPalette(int Bpp)
 {
   SetBpp(Bpp);
+  SetAntiAliasGranularity(10, 10);
+}
+
+void cPalette::SetAntiAliasGranularity(uint FixedColors, uint BlendColors)
+{
+  if (FixedColors >= MAXNUMCOLORS || BlendColors == 0)
+     antiAliasGranularity = MAXNUMCOLORS - 1;
+  else {
+     int ColorsForBlending = MAXNUMCOLORS - FixedColors;
+     int ColorsPerBlend = ColorsForBlending / BlendColors + 2; // +2 = the full foreground and background colors, which are amoung the fixed colors
+     antiAliasGranularity = double(MAXNUMCOLORS - 1) / (ColorsPerBlend - 1);
+     }
 }
 
 void cPalette::Reset(void)
@@ -30,18 +43,23 @@
 
 int cPalette::Index(tColor Color)
 {
+  // Check if color is already defined:
   for (int i = 0; i < numColors; i++) {
       if (color[i] == Color)
          return i;
       }
+  // No exact color, try a close one:
+  int i = ClosestColor(Color, 4);
+  if (i >= 0)
+     return i;
+  // No close one, try to define a new one:
   if (numColors < maxColors) {
      color[numColors++] = Color;
      modified = true;
      return numColors - 1;
      }
-  dsyslog("too many different colors used in palette");
-  //TODO: return the index of the "closest" color?
-  return 0;
+  // Out of colors, so any close color must do:
+  return ClosestColor(Color);
 }
 
 void cPalette::SetBpp(int Bpp)
@@ -91,6 +109,48 @@
   for (int i = 0; i < Palette.numColors; i++)
       SetColor(i, Palette.color[i]);
   numColors = Palette.numColors;
+  antiAliasGranularity = Palette.antiAliasGranularity;
+}
+
+tColor cPalette::Blend(tColor ColorFg, tColor ColorBg, uint8_t Level)
+{
+  if (antiAliasGranularity > 0)
+     Level = uint8_t(int(Level / antiAliasGranularity + 0.5) * antiAliasGranularity);
+  int Af = (ColorFg & 0xFF000000) >> 24;
+  int Rf = (ColorFg & 0x00FF0000) >> 16;
+  int Gf = (ColorFg & 0x0000FF00) >>  8;
+  int Bf = (ColorFg & 0x000000FF);
+  int Ab = (ColorBg & 0xFF000000) >> 24;
+  int Rb = (ColorBg & 0x00FF0000) >> 16;
+  int Gb = (ColorBg & 0x0000FF00) >>  8;
+  int Bb = (ColorBg & 0x000000FF);
+  int A = (Ab + (Af - Ab) * Level / 0xFF) & 0xFF;
+  int R = (Rb + (Rf - Rb) * Level / 0xFF) & 0xFF;
+  int G = (Gb + (Gf - Gb) * Level / 0xFF) & 0xFF;
+  int B = (Bb + (Bf - Bb) * Level / 0xFF) & 0xFF;
+  return (A << 24) | (R << 16) | (G << 8) | B;
+}
+
+int cPalette::ClosestColor(tColor Color, int MaxDiff)
+{
+  int n = 0;
+  int d = INT_MAX;
+  int A1 = (Color & 0xFF000000) >> 24;
+  int R1 = (Color & 0x00FF0000) >> 16;
+  int G1 = (Color & 0x0000FF00) >>  8;
+  int B1 = (Color & 0x000000FF);
+  for (int i = 0; i < numColors; i++) {
+      int A2 = (color[i] & 0xFF000000) >> 24;
+      int R2 = (color[i] & 0x00FF0000) >> 16;
+      int G2 = (color[i] & 0x0000FF00) >>  8;
+      int B2 = (color[i] & 0x000000FF);
+      int diff = (abs(A1 - A2) << 1) + (abs(R1 - R2) << 1) + (abs(G1 - G2) << 1) + (abs(B1 - B2) << 1);
+      if (diff < d) {
+         d = diff;
+         n = i;
+         }
+      }
+  return d <= MaxDiff ? n : -1;
 }
 
 // --- cBitmap ---------------------------------------------------------------
@@ -424,26 +484,7 @@
         return;
      x -= x0;
      y -= y0;
-     tIndex fg = Index(ColorFg);
-     tIndex bg = (ColorBg != clrTransparent) ? Index(ColorBg) : 0;
-     while (s && *s) {
-           const cFont::tCharData *CharData = Font->CharData(*s++);
-           if (limit && int(x + CharData->width) > limit)
-              break; // we don't draw partial characters
-           if (int(x + CharData->width) > 0) {
-              for (int row = 0; row < h; row++) {
-                  cFont::tPixelData PixelData = CharData->lines[row];
-                  for (int col = CharData->width; col-- > 0; ) {
-                      if (ColorBg != clrTransparent || (PixelData & 1))
-                         SetIndex(x + col, y + row, (PixelData & 1) ? fg : bg);
-                      PixelData >>= 1;
-                      }
-                  }
-              }
-           x += CharData->width;
-           if (x > width - 1)
-              break;
-           }
+     Font->DrawText(this, x, y, s, ColorFg, ColorBg, limit);
      }
 }
 
@@ -623,6 +664,12 @@
   isOpen--;
 }
 
+void cOsd::SetAntiAliasGranularity(uint FixedColors, uint BlendColors)
+{
+  for (int i = 0; i < numBitmaps; i++)
+      bitmaps[i]->SetAntiAliasGranularity(FixedColors, BlendColors);
+}
+
 cBitmap *cOsd::GetBitmap(int Area)
 {
   return Area < numBitmaps ? bitmaps[Area] : NULL;
diff -ruN vdr-1.5.2/osd.h vdr-1.5.3/osd.h
--- vdr-1.5.2/osd.h	2006-02-26 15:45:05.000000000 +0100
+++ vdr-1.5.3/osd.h	2007-06-10 14:15:52.000000000 +0200
@@ -4,12 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 1.53 2006/02/26 14:45:05 kls Exp $
+ * $Id: osd.h 1.54 2007/06/10 12:15:52 kls Exp $
  */
 
 #ifndef __OSD_H
 #define __OSD_H
 
+#include <limits.h>
 #include <stdio.h>
 #include <stdint.h>
 #include "font.h"
@@ -41,7 +42,7 @@
                  oeUnknown,
                };
 
-typedef uint32_t tColor;
+typedef uint32_t tColor; // see also font.h
 typedef uint8_t tIndex;
 
 class cPalette {
@@ -50,11 +51,22 @@
   int bpp;
   int maxColors, numColors;
   bool modified;
+  double antiAliasGranularity;
 protected:
   typedef tIndex tIndexes[MAXNUMCOLORS];
 public:
   cPalette(int Bpp = 8);
         ///< Initializes the palette with the given color depth.
+  void SetAntiAliasGranularity(uint FixedColors, uint BlendColors);
+        ///< Allows the system to optimize utilization of the limited color
+        ///< palette entries when generating blended colors for anti-aliasing.
+        ///< FixedColors is the maximum number of colors used, and BlendColors
+        ///< is the maximum number of foreground/background color combinations
+        ///< used with anti-aliasing. If this function is not called with
+        ///< useful values, the palette may be filled up with many shades of
+        ///< a single color combination, and may not be able to serve all
+        ///< requested colors. By default the palette assumes there will be
+        ///< 10 fixed colors and 10 color combinations.
   int Bpp(void) { return bpp; }
   void Reset(void);
         ///< Resets the palette, making it contain no colors.
@@ -62,7 +74,7 @@
         ///< Returns the index of the given Color (the first color has index 0).
         ///< If Color is not yet contained in this palette, it will be added if
         ///< there is a free slot. If the color can't be added to this palette,
-        ///< 0 will be returned.
+        ///< the closest existing color will be returned.
   tColor Color(int Index) { return Index < maxColors ? color[Index] : 0; }
         ///< Returns the color at the given Index. If Index is outside the valid
         ///< range, 0 will be returned.
@@ -88,6 +100,18 @@
   void Replace(const cPalette &Palette);
         ///< Replaces the colors of this palette with the colors from the given
         ///< palette.
+  tColor Blend(tColor ColorFg, tColor ColorBg, uint8_t Level);
+        ///< Determines a color that consists of a linear blend between ColorFg
+        ///< and ColorBg. If Level is 0, the result is ColorBg, if it is 255,
+        ///< the result is ColorFg. If SetAntiAliasGranularity() has been called previously,
+        ///< Level will be mapped to a limited range of levels that allow to make best
+        ///< use of the palette entries.
+  int ClosestColor(tColor Color, int MaxDiff = INT_MAX);
+        ///< Returns the index of a color in this paltte that is closest to the given
+        ///< Color. MaxDiff can be used to control the maximum allowed color difference.
+        ///< If no color with a maximum difference of MaxDiff can be found, -1 will
+        ///< be returned. With the default value of INT_MAX, there will always be
+        ///< a valid color index returned, but the color may be completely different.
   };
 
 enum eTextAlignment { taCenter  = 0x00,
@@ -98,6 +122,8 @@
                       taDefault = taTop | taLeft
                     };
 
+class cFont;
+
 class cBitmap : public cPalette {
 private:
   tIndex *bitmap;
@@ -202,6 +228,8 @@
        ///< 7: vertical,   falling, upper
   const tIndex *Data(int x, int y);
        ///< Returns the address of the index byte at the given coordinates.
+  tColor GetColor(int x, int y) { return Color(*Data(x, y)); }
+       ///< Returns the color at the given coordinates.
   };
 
 struct tArea {
@@ -247,6 +275,16 @@
   int Top(void) { return top; }
   int Width(void) { return width; }
   int Height(void) { return height; }
+  void SetAntiAliasGranularity(uint FixedColors, uint BlendColors);
+       ///< Allows the system to optimize utilization of the limited color
+       ///< palette entries when generating blended colors for anti-aliasing.
+       ///< FixedColors is the maximum number of colors used, and BlendColors
+       ///< is the maximum number of foreground/background color combinations
+       ///< used with anti-aliasing. If this function is not called with
+       ///< useful values, the palette may be filled up with many shades of
+       ///< a single color combination, and may not be able to serve all
+       ///< requested colors. By default the palette assumes there will be
+       ///< 10 fixed colors and 10 color combinations.
   cBitmap *GetBitmap(int Area);
        ///< Returns a pointer to the bitmap for the given Area, or NULL if no
        ///< such bitmap exists.
diff -ruN vdr-1.5.2/osdbase.c vdr-1.5.3/osdbase.c
--- vdr-1.5.2/osdbase.c	2007-01-05 11:41:16.000000000 +0100
+++ vdr-1.5.3/osdbase.c	2007-06-09 12:07:46.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 1.30 2007/01/05 10:41:16 kls Exp $
+ * $Id: osdbase.c 1.31 2007/06/09 10:07:46 kls Exp $
  */
 
 #include "osdbase.h"
@@ -86,10 +86,8 @@
   subMenu = NULL;
   helpRed = helpGreen = helpYellow = helpBlue = NULL;
   status = NULL;
-  if (!displayMenuCount++) {
-     displayMenu = Skins.Current()->DisplayMenu();
-     displayMenuItems = displayMenu->MaxItems();
-     }
+  if (!displayMenuCount++)
+     SetDisplayMenu();
 }
 
 cOsdMenu::~cOsdMenu()
@@ -103,15 +101,25 @@
      DELETENULL(displayMenu);
 }
 
+void cOsdMenu::SetDisplayMenu(void)
+{
+  if (displayMenu) {
+     displayMenu->Clear();
+     delete displayMenu;
+     }
+  displayMenu = Skins.Current()->DisplayMenu();
+  displayMenuItems = displayMenu->MaxItems();
+}
+
 const char *cOsdMenu::hk(const char *s)
 {
-  static char buffer[64];
+  static cString buffer;
   if (s && hasHotkeys) {
      if (digit == 0 && '1' <= *s && *s <= '9' && *(s + 1) == ' ')
         digit = -1; // prevents automatic hotkeys - input already has them
      if (digit >= 0) {
         digit++;
-        snprintf(buffer, sizeof(buffer), " %c %s", (digit < 10) ? '0' + digit : ' ' , s);
+        buffer = cString::sprintf(" %c %s", (digit < 10) ? '0' + digit : ' ' , s);
         s = buffer;
         }
      }
diff -ruN vdr-1.5.2/osdbase.h vdr-1.5.3/osdbase.h
--- vdr-1.5.2/osdbase.h	2007-01-05 11:41:32.000000000 +0100
+++ vdr-1.5.3/osdbase.h	2007-06-09 13:49:00.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.h 1.15 2007/01/05 10:41:32 kls Exp $
+ * $Id: osdbase.h 1.16 2007/06/09 11:49:00 kls Exp $
  */
 
 #ifndef __OSDBASE_H
@@ -96,6 +96,7 @@
   int digit;
   bool hasHotkeys;
 protected:
+  void SetDisplayMenu(void);
   cSkinDisplayMenu *DisplayMenu(void) { return displayMenu; }
   const char *hk(const char *s);
   void SetCols(int c0, int c1 = 0, int c2 = 0, int c3 = 0, int c4 = 0);
diff -ruN vdr-1.5.2/remote.c vdr-1.5.3/remote.c
--- vdr-1.5.2/remote.c	2007-02-24 14:23:12.000000000 +0100
+++ vdr-1.5.3/remote.c	2007-04-30 14:27:56.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.56 2007/02/24 13:23:12 kls Exp $
+ * $Id: remote.c 1.57 2007/04/30 12:27:56 kls Exp $
  */
 
 #include "remote.h"
@@ -31,6 +31,7 @@
 cCondVar cRemote::keyPressed;
 const char *cRemote::keyMacroPlugin = NULL;
 const char *cRemote::callPlugin = NULL;
+bool cRemote::enabled = true;
 time_t cRemote::lastActivity = 0;
 
 cRemote::cRemote(const char *Name)
@@ -185,7 +186,7 @@
          if ((k & k_Repeat) != 0)
             repeatTimeout.Set(REPEATTIMEOUT);
          lastActivity = time(NULL);
-         return k;
+         return enabled ? k : kNone;
          }
       else if (!WaitMs || !keyPressed.TimedWait(mutex, WaitMs) && repeatTimeout.TimedOut())
          return kNone;
diff -ruN vdr-1.5.2/remote.h vdr-1.5.3/remote.h
--- vdr-1.5.2/remote.h	2007-02-24 16:53:00.000000000 +0100
+++ vdr-1.5.3/remote.h	2007-04-30 14:37:37.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.39 2007/02/24 15:53:00 kls Exp $
+ * $Id: remote.h 1.40 2007/04/30 12:37:37 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -31,6 +31,7 @@
   static time_t lastActivity;
   static const char *keyMacroPlugin;
   static const char *callPlugin;
+  static bool enabled;
   char *name;
 protected:
   cRemote(const char *Name);
@@ -45,6 +46,8 @@
   const char *Name(void) { return name; }
   static void SetLearning(cRemote *Learning) { learning = Learning; }
   static bool IsLearning() { return learning != NULL; }
+  static bool Enabled(void) { return enabled; }
+  static void SetEnabled(bool Enabled) { enabled = Enabled; }
   static void Clear(void);
   static bool Put(eKeys Key, bool AtFront = false);
   static bool PutMacro(eKeys Key);
diff -ruN vdr-1.5.2/sdt.c vdr-1.5.3/sdt.c
--- vdr-1.5.2/sdt.c	2006-04-15 16:12:21.000000000 +0200
+++ vdr-1.5.3/sdt.c	2007-06-10 10:50:49.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sdt.c 1.16 2006/04/15 14:12:21 kls Exp $
+ * $Id: sdt.c 1.17 2007/06/10 08:50:49 kls Exp $
  */
 
 #include "sdt.h"
@@ -56,9 +56,9 @@
                    case 0x04: // NVOD reference service
                    case 0x05: // NVOD time-shifted service
                         {
-                        char NameBuf[1024];
-                        char ShortNameBuf[1024];
-                        char ProviderNameBuf[1024];
+                        char NameBuf[Utf8BufSize(1024)];
+                        char ShortNameBuf[Utf8BufSize(1024)];
+                        char ProviderNameBuf[Utf8BufSize(1024)];
                         sd->serviceName.getText(NameBuf, ShortNameBuf, sizeof(NameBuf), sizeof(ShortNameBuf));
                         char *pn = compactspace(NameBuf);
                         char *ps = compactspace(ShortNameBuf);
diff -ruN vdr-1.5.2/skinclassic.c vdr-1.5.3/skinclassic.c
--- vdr-1.5.2/skinclassic.c	2006-03-31 15:59:50.000000000 +0200
+++ vdr-1.5.3/skinclassic.c	2007-06-10 14:42:02.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.15 2006/03/31 13:59:50 kls Exp $
+ * $Id: skinclassic.c 1.16 2007/06/10 12:42:02 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -94,8 +94,13 @@
   message = false;
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + (Setup.ChannelInfoPos ? 0 : Setup.OSDHeight - Lines * lineHeight));
   timeWidth = font->Width("00:00") + 4;
-  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, Lines * lineHeight - 1, 4 } };
-  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, Lines * lineHeight - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  else {
+     tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, Lines * lineHeight - 1, 4 } };
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     }
   osd->DrawRectangle(0, 0, osd->Width() - 1, osd->Height() - 1, Theme.Color(clrBackground));
 }
 
@@ -142,7 +147,9 @@
 {
   if (!message) {
      cString date = DayDateTime();
-     osd->DrawText(osd->Width() - cFont::GetFont(fontSml)->Width(date) - 2, 0, date, Theme.Color(clrChannelDate), Theme.Color(clrBackground), cFont::GetFont(fontSml));
+     const cFont *font = cFont::GetFont(fontSml);
+     int w = font->Width(date);
+     osd->DrawText(osd->Width() - w - 2, 0, date, Theme.Color(clrChannelDate), Theme.Color(clrBackground), cFont::GetFont(fontSml), w);
      }
   osd->Flush();
 }
@@ -155,6 +162,7 @@
   int x0, x1;
   int y0, y1, y2, y3, y4, y5;
   int lineHeight;
+  cString lastDate;
   void SetScrollbar(void);
 public:
   cSkinClassicDisplayMenu(void);
@@ -187,15 +195,20 @@
   y4 = y5 - lineHeight;
   y3 = y4 - lineHeight;
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop);
-  tArea Areas[] = { { x0, y0, x1 - 1, y5 - 1, 4 } };
-  if (osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+  tArea Areas[] = { { x0, y0, x1 - 1, y5 - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
      osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
   else {
-     tArea Areas[] = { { x0, y0, x1 - 1, y1 - 1, 2 },
-                       { x0, y1, x1 - 1, y3 - 1, 2 },
-                       { x0, y3, x1 - 1, y5 - 1, 4 }
-                     };
-     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     tArea Areas[] = { { x0, y0, x1 - 1, y5 - 1, 4 } };
+     if (osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+        osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     else {
+        tArea Areas[] = { { x0, y0, x1 - 1, y1 - 1, 2 },
+                          { x0, y1, x1 - 1, y3 - 1, 2 },
+                          { x0, y3, x1 - 1, y5 - 1, 4 }
+                        };
+        osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+        }
      }
   osd->DrawRectangle(x0, y0, x1 - 1, y5 - 1, Theme.Color(clrBackground));
 }
@@ -305,9 +318,10 @@
   ts.Set(osd, xl, y, x1 - xl, y3 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
   if (Event->Vps() && Event->Vps() != Event->StartTime()) {
      char *buffer;
-     asprintf(&buffer, " VPS: %s", *Event->GetVpsString());
+     asprintf(&buffer, " VPS: %s ", *Event->GetVpsString());
      const cFont *font = cFont::GetFont(fontSml);
-     osd->DrawText(x1 - font->Width(buffer), y, buffer, Theme.Color(clrMenuEventVpsFg), Theme.Color(clrMenuEventVpsBg), font);
+     int w = font->Width(buffer);
+     osd->DrawText(x1 - w, y, buffer, Theme.Color(clrMenuEventVpsFg), Theme.Color(clrMenuEventVpsBg), font, w);
      free(buffer);
      }
   y += ts.Height();
@@ -376,8 +390,12 @@
 void cSkinClassicDisplayMenu::Flush(void)
 {
   cString date = DayDateTime();
-  const cFont *font = cFont::GetFont(fontOsd);
-  osd->DrawText(x1 - font->Width(date) - 2, y0, date, Theme.Color(clrMenuDate), Theme.Color(clrMenuTitleBg), font);
+  if (!lastDate || strcmp(date, lastDate)) {
+     const cFont *font = cFont::GetFont(fontOsd);
+     int w = font->Width(date);
+     osd->DrawText(x1 - w - 2, y0, date, Theme.Color(clrMenuDate), Theme.Color(clrMenuTitleBg), font, w);
+     lastDate = date;
+     }
   osd->Flush();
 }
 
@@ -414,8 +432,13 @@
   y2 = 2 * lineHeight;
   y3 = 3 * lineHeight;
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + Setup.OSDHeight - y3);
-  tArea Areas[] = { { x0, y0, x1 - 1, y3 - 1, 4 } };
-  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  tArea Areas[] = { { x0, y0, x1 - 1, y3 - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  else {
+     tArea Areas[] = { { x0, y0, x1 - 1, y3 - 1, 4 } };
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     }
   osd->DrawRectangle(x0, y0, x1 - 1, y3 - 1, ModeOnly ? clrTransparent : Theme.Color(clrBackground));
 }
 
@@ -455,14 +478,15 @@
 {
   const cFont *font = cFont::GetFont(fontOsd);
   int w = font->Width(Current);
-  osd->DrawText(x0, y2, Current, Theme.Color(clrReplayCurrent), Theme.Color(clrBackground), font, lastCurrentWidth > w ? lastCurrentWidth : 0);
+  osd->DrawText(x0, y2, Current, Theme.Color(clrReplayCurrent), Theme.Color(clrBackground), font, lastCurrentWidth > w ? lastCurrentWidth : w);
   lastCurrentWidth = w;
 }
 
 void cSkinClassicDisplayReplay::SetTotal(const char *Total)
 {
   const cFont *font = cFont::GetFont(fontOsd);
-  osd->DrawText(x1 - font->Width(Total), y2, Total, Theme.Color(clrReplayTotal), Theme.Color(clrBackground), font);
+  int w = font->Width(Total);
+  osd->DrawText(x1 - font->Width(Total), y2, Total, Theme.Color(clrReplayTotal), Theme.Color(clrBackground), font, w);
 }
 
 void cSkinClassicDisplayReplay::SetJump(const char *Jump)
@@ -503,8 +527,13 @@
   const cFont *font = cFont::GetFont(fontOsd);
   int lineHeight = font->Height();
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + Setup.OSDHeight - lineHeight);
-  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 4 } };
-  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  else {
+     tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 4 } };
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     }
 }
 
 cSkinClassicDisplayVolume::~cSkinClassicDisplayVolume()
@@ -572,8 +601,13 @@
   y1 = lineHeight;
   y2 = y1 + NumTracks * lineHeight;
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + Setup.OSDHeight - y2);
-  tArea Areas[] = { { x0, y0, x1 - 1, y2 - 1, 4 } };
-  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  tArea Areas[] = { { x0, y0, x1 - 1, y2 - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  else {
+     tArea Areas[] = { { x0, y0, x1 - 1, y2 - 1, 4 } };
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     }
   osd->DrawText(x0, y0, Title, Theme.Color(clrMenuTitleFg), Theme.Color(clrMenuTitleBg), font, x1 - x0);
   for (int i = 0; i < NumTracks; i++)
       SetItem(Tracks[i], i, false);
@@ -630,8 +664,13 @@
   const cFont *font = cFont::GetFont(fontOsd);
   int lineHeight = font->Height();
   osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + Setup.OSDHeight - lineHeight);
-  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 2 } };
-  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 8 } };
+  if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+  else {
+     tArea Areas[] = { { 0, 0, Setup.OSDWidth - 1, lineHeight - 1, 2 } };
+     osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
+     }
 }
 
 cSkinClassicDisplayMessage::~cSkinClassicDisplayMessage()
